##// END OF EJS Templates
libnss-systemd was missing
Unknown -
r427:6dffc133c71d
parent child
Show More
@@ -1,811 +1,811
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 #Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 #BIS= Kernel has KVM and zswap enabled
60 60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
61 61 #default bcmrpi3_defconfig target kernel
62 62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
63 63 #enhanced kernel
64 64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
65 65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
66 66
67 67 # Build directories
68 68 WORKDIR=$(pwd)
69 69 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
70 70 BUILDDIR="${BASEDIR}/build"
71 71
72 72 # Chroot directories
73 73 R="${BUILDDIR}/chroot"
74 74 ETC_DIR="${R}/etc"
75 75 LIB_DIR="${R}/lib"
76 76 BOOT_DIR="${R}/boot/firmware"
77 77 KERNEL_DIR="${R}/usr/src/linux"
78 78 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
79 79
80 80 # Firmware directory: Blank if download from github
81 81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82 82
83 83 # General settings
84 84 SET_ARCH=${SET_ARCH:=32}
85 85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 86 PASSWORD=${PASSWORD:=raspberry}
87 87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 90 EXPANDROOT=${EXPANDROOT:=true}
91 91
92 92 # Keyboard settings
93 93 XKB_MODEL=${XKB_MODEL:=""}
94 94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 95 XKB_VARIANT=${XKB_VARIANT:=""}
96 96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97 97
98 98 # Network settings (DHCP)
99 99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100 100
101 101 # Network settings (static)
102 102 NET_ADDRESS=${NET_ADDRESS:=""}
103 103 NET_GATEWAY=${NET_GATEWAY:=""}
104 104 NET_DNS_1=${NET_DNS_1:=""}
105 105 NET_DNS_2=${NET_DNS_2:=""}
106 106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 107 NET_NTP_1=${NET_NTP_1:=""}
108 108 NET_NTP_2=${NET_NTP_2:=""}
109 109
110 110 # APT settings
111 111 APT_PROXY=${APT_PROXY:=""}
112 112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113 113
114 114 # Feature settings
115 115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 116 ENABLE_I2C=${ENABLE_I2C:=false}
117 117 ENABLE_SPI=${ENABLE_SPI:=false}
118 118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 126 ENABLE_XORG=${ENABLE_XORG:=false}
127 127 ENABLE_WM=${ENABLE_WM:=""}
128 128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 129 ENABLE_USER=${ENABLE_USER:=true}
130 130 USER_NAME=${USER_NAME:="pi"}
131 131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133 133 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
134 134
135 135 # SSH settings
136 136 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
137 137 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
138 138 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
139 139 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
140 140 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
141 141
142 142 # Advanced settings
143 143 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
144 144 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
145 145 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
146 146 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
147 147 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
148 148 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
149 149 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
150 150 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
151 151 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
152 152 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
153 153 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
154 154 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
155 155 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
156 156 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
157 157 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
158 158
159 159 # Kernel compilation settings
160 160 BUILD_KERNEL=${BUILD_KERNEL:=true}
161 161 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
162 162 KERNEL_THREADS=${KERNEL_THREADS:=1}
163 163 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
164 164 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
165 165 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
166 166 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
167 167 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
168 168 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
169 169 KERNEL_VIRT=${KERNEL_VIRT:=false}
170 170 KERNEL_BPF=${KERNEL_BPF:=false}
171 171
172 172 # Kernel compilation from source directory settings
173 173 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
174 174 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
175 175 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
176 176 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
177 177
178 178 # Reduce disk usage settings
179 179 REDUCE_APT=${REDUCE_APT:=true}
180 180 REDUCE_DOC=${REDUCE_DOC:=true}
181 181 REDUCE_MAN=${REDUCE_MAN:=true}
182 182 REDUCE_VIM=${REDUCE_VIM:=false}
183 183 REDUCE_BASH=${REDUCE_BASH:=false}
184 184 REDUCE_HWDB=${REDUCE_HWDB:=true}
185 185 REDUCE_SSHD=${REDUCE_SSHD:=true}
186 186 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
187 187
188 188 # Encrypted filesystem settings
189 189 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
190 190 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
191 191 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
192 192 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
193 193 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
194 194
195 195 # Chroot scripts directory
196 196 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
197 197
198 198 # Packages required in the chroot build environment
199 199 APT_INCLUDES=${APT_INCLUDES:=""}
200 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
200 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
201 201
202 202 #Packages to exclude from chroot build environment
203 203 APT_EXCLUDES=${APT_EXCLUDES:=""}
204 204
205 205 # Packages required for bootstrapping
206 206 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
207 207 MISSING_PACKAGES=""
208 208
209 209 # Packages installed for c/c++ build environment in chroot (keep empty)
210 210 COMPILER_PACKAGES=""
211 211
212 212 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
213 213 if [ -n "$(lsof -i :3142)" ] ; then
214 214 HTTP_PROXY=http://127.0.0.1:3142/
215 215 fi
216 216
217 217 #netselect-apt does not know buster yet
218 218 if [ "$RELEASE" = "buster" ] ; then
219 219 RLS=testing
220 220 else
221 221 RLS="$RELEASE"
222 222 fi
223 223
224 224 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
225 225 rm "$(pwd)/files/apt/sources.list"
226 226 fi
227 227
228 228 if [ "$ENABLE_NONFREE" = true ] ; then
229 229 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
230 230 else
231 231 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
232 232 fi
233 233
234 234 #sed and cut the result string so we can use it as APT_SERVER
235 235 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
236 236
237 237 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
238 238 if [ -n "$SET_ARCH" ] ; then
239 239 # 64 bit configuration
240 240 if [ "$SET_ARCH" = 64 ] ; then
241 241 # General 64 bit depended settings
242 242 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
243 243 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
244 244 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
245 245
246 246 # Board specific settings
247 247 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
248 248 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
249 249 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
250 250 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
251 251 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
252 252 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
253 253 else
254 254 echo "error: Only Raspberry PI 3 and 3B+ support 64 bit"
255 255 exit 1
256 256 fi
257 257 fi
258 258
259 259 # 32 bit configuration
260 260 if [ "$SET_ARCH" = 32 ] ; then
261 261 # General 32 bit dependend settings
262 262 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
263 263 KERNEL_ARCH=${KERNEL_ARCH:=arm}
264 264 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
265 265
266 266 # Hardware specific settings
267 267 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
268 268 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
269 269 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
270 270 RELEASE_ARCH=${RELEASE_ARCH:=armel}
271 271 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
272 272 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
273 273 fi
274 274
275 275 # Hardware specific settings
276 276 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
277 277 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
278 278 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
279 279 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
280 280 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
281 281 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
282 282 fi
283 283 fi
284 284 #SET_ARCH not set
285 285 else
286 286 echo "error: Please set '32' or '64' as value for SET_ARCH"
287 287 exit 1
288 288 fi
289 # Device specific configuration and U-Boot configuration
290 case "$RPI_MODEL" in
291 0)
292 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
293 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
294 ;;
295 1)
296 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
297 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
298 ;;
299 1P)
300 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
301 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
302 ;;
303 2)
304 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
305 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
306 ;;
307 3)
308 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
309 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
310 ;;
311 3P)
312 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
313 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
314 ;;
315 *)
316 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
317 exit 1
318 ;;
319 esac
289 # Device specific configuration and U-Boot configuration
290 case "$RPI_MODEL" in
291 0)
292 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
293 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
294 ;;
295 1)
296 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
297 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
298 ;;
299 1P)
300 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
301 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
302 ;;
303 2)
304 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
305 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
306 ;;
307 3)
308 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
309 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
310 ;;
311 3P)
312 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
313 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
314 ;;
315 *)
316 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
317 exit 1
318 ;;
319 esac
320 320
321 321 # Prepare date string for default image file name
322 322 DATE="$(date +%Y-%m-%d)"
323 323 if [ -z "$KERNEL_BRANCH" ] ; then
324 324 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
325 325 else
326 326 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
327 327 fi
328 328
329 329 # Check if the internal wireless interface is supported by the RPi model
330 330 if [ "$ENABLE_WIRELESS" = true ] ; then
331 331 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
332 332 echo "error: The selected Raspberry Pi model has no internal wireless interface"
333 333 exit 1
334 334 fi
335 335 fi
336 336
337 337 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
338 338 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
339 339 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
340 340 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
341 341 exit 1
342 342 fi
343 343 fi
344 344
345 345 # Add cmake to compile videocore sources
346 346 if [ "$ENABLE_VIDEOCORE" = true ] ; then
347 347 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
348 348 fi
349 349
350 350 # Add libncurses5 to enable kernel menuconfig
351 351 if [ "$KERNEL_MENUCONFIG" = true ] ; then
352 352 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
353 353 fi
354 354
355 355 # Add ccache compiler cache for (faster) kernel cross (re)compilation
356 356 if [ "$KERNEL_CCACHE" = true ] ; then
357 357 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
358 358 fi
359 359
360 360 # Add cryptsetup package to enable filesystem encryption
361 361 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
362 362 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
363 363 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
364 364
365 365 if [ -z "$CRYPTFS_PASSWORD" ] ; then
366 366 echo "error: no password defined (CRYPTFS_PASSWORD)!"
367 367 exit 1
368 368 fi
369 369 ENABLE_INITRAMFS=true
370 370 fi
371 371
372 372 # Add initramfs generation tools
373 373 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
374 374 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
375 375 fi
376 376
377 377 # Add device-tree-compiler required for building the U-Boot bootloader
378 378 if [ "$ENABLE_UBOOT" = true ] ; then
379 379 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
380 380 else
381 381 if [ "$ENABLE_UBOOTUSB" = true ] ; then
382 382 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
383 383 exit 1
384 384 fi
385 385 fi
386 386
387 387 # Check if root SSH (v2) public key file exists
388 388 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
389 389 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
390 390 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
391 391 exit 1
392 392 fi
393 393 fi
394 394
395 395 # Check if $USER_NAME SSH (v2) public key file exists
396 396 if [ -n "$SSH_USER_PUB_KEY" ] ; then
397 397 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
398 398 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
399 399 exit 1
400 400 fi
401 401 fi
402 402
403 403 # Check if all required packages are installed on the build system
404 404 for package in $REQUIRED_PACKAGES ; do
405 405 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
406 406 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
407 407 fi
408 408 done
409 409
410 410 # If there are missing packages ask confirmation for install, or exit
411 411 if [ -n "$MISSING_PACKAGES" ] ; then
412 412 echo "the following packages needed by this script are not installed:"
413 413 echo "$MISSING_PACKAGES"
414 414
415 415 printf "\ndo you want to install the missing packages right now? [y/n] "
416 416 read -r confirm
417 417 [ "$confirm" != "y" ] && exit 1
418 418
419 419 # Make sure all missing required packages are installed
420 420 apt-get -qq -y install "${MISSING_PACKAGES}"
421 421 fi
422 422
423 423 # Check if ./bootstrap.d directory exists
424 424 if [ ! -d "./bootstrap.d/" ] ; then
425 425 echo "error: './bootstrap.d' required directory not found!"
426 426 exit 1
427 427 fi
428 428
429 429 # Check if ./files directory exists
430 430 if [ ! -d "./files/" ] ; then
431 431 echo "error: './files' required directory not found!"
432 432 exit 1
433 433 fi
434 434
435 435 # Check if specified KERNELSRC_DIR directory exists
436 436 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
437 437 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
438 438 exit 1
439 439 fi
440 440
441 441 # Check if specified UBOOTSRC_DIR directory exists
442 442 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
443 443 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
444 444 exit 1
445 445 fi
446 446
447 447 # Check if specified VIDEOCORESRC_DIR directory exists
448 448 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
449 449 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
450 450 exit 1
451 451 fi
452 452
453 453 # Check if specified FBTURBOSRC_DIR directory exists
454 454 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
455 455 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
456 456 exit 1
457 457 fi
458 458
459 459 # Check if specified CHROOT_SCRIPTS directory exists
460 460 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
461 461 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
462 462 exit 1
463 463 fi
464 464
465 465 # Check if specified device mapping already exists (will be used by cryptsetup)
466 466 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
467 467 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
468 468 exit 1
469 469 fi
470 470
471 471 # Don't clobber an old build
472 472 if [ -e "$BUILDDIR" ] ; then
473 473 echo "error: directory ${BUILDDIR} already exists, not proceeding"
474 474 exit 1
475 475 fi
476 476
477 477 # Setup chroot directory
478 478 mkdir -p "${R}"
479 479
480 480 # Check if build directory has enough of free disk space >512MB
481 481 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
482 482 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
483 483 exit 1
484 484 fi
485 485
486 486 set -x
487 487
488 488 # Call "cleanup" function on various signals and errors
489 489 trap cleanup 0 1 2 3 6
490 490
491 491 # Add required packages for the minbase installation
492 492 if [ "$ENABLE_MINBASE" = true ] ; then
493 493 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
494 494 fi
495 495
496 496 # Add parted package, required to get partprobe utility
497 497 if [ "$EXPANDROOT" = true ] ; then
498 498 APT_INCLUDES="${APT_INCLUDES},parted"
499 499 fi
500 500
501 501 # Add dbus package, recommended if using systemd
502 502 if [ "$ENABLE_DBUS" = true ] ; then
503 503 APT_INCLUDES="${APT_INCLUDES},dbus"
504 504 fi
505 505
506 506 # Add iptables IPv4/IPv6 package
507 507 if [ "$ENABLE_IPTABLES" = true ] ; then
508 508 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
509 509 fi
510 510
511 511 # Add openssh server package
512 512 if [ "$ENABLE_SSHD" = true ] ; then
513 513 APT_INCLUDES="${APT_INCLUDES},openssh-server"
514 514 fi
515 515
516 516 # Add alsa-utils package
517 517 if [ "$ENABLE_SOUND" = true ] ; then
518 518 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
519 519 fi
520 520
521 521 # Add rng-tools package
522 522 if [ "$ENABLE_HWRANDOM" = true ] ; then
523 523 APT_INCLUDES="${APT_INCLUDES},rng-tools"
524 524 fi
525 525
526 526 # Add fbturbo video driver
527 527 if [ "$ENABLE_FBTURBO" = true ] ; then
528 528 # Enable xorg package dependencies
529 529 ENABLE_XORG=true
530 530 fi
531 531
532 532 # Add user defined window manager package
533 533 if [ -n "$ENABLE_WM" ] ; then
534 534 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
535 535
536 536 # Enable xorg package dependencies
537 537 ENABLE_XORG=true
538 538 fi
539 539
540 540 # Add xorg package
541 541 if [ "$ENABLE_XORG" = true ] ; then
542 542 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
543 543 fi
544 544
545 545 # Replace selected packages with smaller clones
546 546 if [ "$ENABLE_REDUCE" = true ] ; then
547 547 # Add levee package instead of vim-tiny
548 548 if [ "$REDUCE_VIM" = true ] ; then
549 549 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
550 550 fi
551 551
552 552 # Add dropbear package instead of openssh-server
553 553 if [ "$REDUCE_SSHD" = true ] ; then
554 554 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
555 555 fi
556 556 fi
557 557
558 558 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
559 559 if [ "$ENABLE_SYSVINIT" = false ] ; then
560 560 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
561 561 fi
562 562
563 563 # Configure kernel sources if no KERNELSRC_DIR
564 564 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
565 565 KERNELSRC_CONFIG=true
566 566 fi
567 567
568 568 # Configure reduced kernel
569 569 if [ "$KERNEL_REDUCE" = true ] ; then
570 570 KERNELSRC_CONFIG=false
571 571 fi
572 572
573 573 # Configure qemu compatible kernel
574 574 if [ "$ENABLE_QEMU" = true ] ; then
575 575 DTB_FILE=vexpress-v2p-ca15_a7.dtb
576 576 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
577 577 KERNEL_DEFCONFIG="vexpress_defconfig"
578 578 if [ "$KERNEL_MENUCONFIG" = false ] ; then
579 579 KERNEL_OLDDEFCONFIG=true
580 580 fi
581 581 fi
582 582
583 583 # Execute bootstrap scripts
584 584 for SCRIPT in bootstrap.d/*.sh; do
585 585 head -n 3 "$SCRIPT"
586 586 . "$SCRIPT"
587 587 done
588 588
589 589 ## Execute custom bootstrap scripts
590 590 if [ -d "custom.d" ] ; then
591 591 for SCRIPT in custom.d/*.sh; do
592 592 . "$SCRIPT"
593 593 done
594 594 fi
595 595
596 596 # Execute custom scripts inside the chroot
597 597 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
598 598 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
599 599 chroot_exec /bin/bash -x <<'EOF'
600 600 for SCRIPT in /chroot_scripts/* ; do
601 601 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
602 602 $SCRIPT
603 603 fi
604 604 done
605 605 EOF
606 606 rm -rf "${R}/chroot_scripts"
607 607 fi
608 608
609 609 # Remove c/c++ build environment from the chroot
610 610 chroot_remove_cc
611 611
612 612 # Generate required machine-id
613 613 MACHINE_ID=$(dbus-uuidgen)
614 614 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
615 615 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
616 616
617 617 # APT Cleanup
618 618 chroot_exec apt-get -y clean
619 619 chroot_exec apt-get -y autoclean
620 620 chroot_exec apt-get -y autoremove
621 621
622 622 # Unmount mounted filesystems
623 623 umount -l "${R}/proc"
624 624 umount -l "${R}/sys"
625 625
626 626 # Clean up directories
627 627 rm -rf "${R}/run/*"
628 628 rm -rf "${R}/tmp/*"
629 629
630 630 # Clean up files
631 631 rm -f "${ETC_DIR}/ssh/ssh_host_*"
632 632 rm -f "${ETC_DIR}/dropbear/dropbear_*"
633 633 rm -f "${ETC_DIR}/apt/sources.list.save"
634 634 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
635 635 rm -f "${ETC_DIR}/*-"
636 636 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
637 637 rm -f "${ETC_DIR}/resolv.conf"
638 638 rm -f "${R}/root/.bash_history"
639 639 rm -f "${R}/var/lib/urandom/random-seed"
640 640 rm -f "${R}/initrd.img"
641 641 rm -f "${R}/vmlinuz"
642 642 rm -f "${R}${QEMU_BINARY}"
643 643
644 644 if [ "$ENABLE_QEMU" = true ] ; then
645 645 # Setup QEMU directory
646 646 mkdir "${BASEDIR}/qemu"
647 647
648 648 # Copy kernel image to QEMU directory
649 649 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
650 650
651 651 # Copy kernel config to QEMU directory
652 652 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
653 653
654 654 # Copy kernel dtbs to QEMU directory
655 655 for dtb in "${BOOT_DIR}/"*.dtb ; do
656 656 if [ -f "${dtb}" ] ; then
657 657 install_readonly "${dtb}" "${BASEDIR}/qemu/"
658 658 fi
659 659 done
660 660
661 661 # Copy kernel overlays to QEMU directory
662 662 if [ -d "${BOOT_DIR}/overlays" ] ; then
663 663 # Setup overlays dtbs directory
664 664 mkdir "${BASEDIR}/qemu/overlays"
665 665
666 666 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
667 667 if [ -f "${dtb}" ] ; then
668 668 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
669 669 fi
670 670 done
671 671 fi
672 672
673 673 # Copy u-boot files to QEMU directory
674 674 if [ "$ENABLE_UBOOT" = true ] ; then
675 675 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
676 676 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
677 677 fi
678 678 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
679 679 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
680 680 fi
681 681 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
682 682 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
683 683 fi
684 684 fi
685 685
686 686 # Copy initramfs to QEMU directory
687 687 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
688 688 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
689 689 fi
690 690 fi
691 691
692 692 # Calculate size of the chroot directory in KB
693 693 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
694 694
695 695 # Calculate the amount of needed 512 Byte sectors
696 696 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
697 697 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
698 698 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
699 699
700 700 # The root partition is EXT4
701 701 # This means more space than the actual used space of the chroot is used.
702 702 # As overhead for journaling and reserved blocks 35% are added.
703 703 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
704 704
705 705 # Calculate required image size in 512 Byte sectors
706 706 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
707 707
708 708 # Prepare image file
709 709 if [ "$ENABLE_SPLITFS" = true ] ; then
710 710 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
711 711 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
712 712 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
713 713 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
714 714
715 715 # Write firmware/boot partition tables
716 716 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
717 717 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
718 718 EOM
719 719
720 720 # Write root partition table
721 721 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
722 722 ${TABLE_SECTORS},${ROOT_SECTORS},83
723 723 EOM
724 724
725 725 # Setup temporary loop devices
726 726 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
727 727 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
728 728 else # ENABLE_SPLITFS=false
729 729 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
730 730 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
731 731
732 732 # Write partition table
733 733 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
734 734 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
735 735 ${ROOT_OFFSET},${ROOT_SECTORS},83
736 736 EOM
737 737
738 738 # Setup temporary loop devices
739 739 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
740 740 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
741 741 fi
742 742
743 743 if [ "$ENABLE_CRYPTFS" = true ] ; then
744 744 # Create dummy ext4 fs
745 745 mkfs.ext4 "$ROOT_LOOP"
746 746
747 747 # Setup password keyfile
748 748 touch .password
749 749 chmod 600 .password
750 750 echo -n ${CRYPTFS_PASSWORD} > .password
751 751
752 752 # Initialize encrypted partition
753 753 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
754 754
755 755 # Open encrypted partition and setup mapping
756 756 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
757 757
758 758 # Secure delete password keyfile
759 759 shred -zu .password
760 760
761 761 # Update temporary loop device
762 762 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
763 763
764 764 # Wipe encrypted partition (encryption cipher is used for randomness)
765 765 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
766 766 fi
767 767
768 768 # Build filesystems
769 769 mkfs.vfat "$FRMW_LOOP"
770 770 mkfs.ext4 "$ROOT_LOOP"
771 771
772 772 # Mount the temporary loop devices
773 773 mkdir -p "$BUILDDIR/mount"
774 774 mount "$ROOT_LOOP" "$BUILDDIR/mount"
775 775
776 776 mkdir -p "$BUILDDIR/mount/boot/firmware"
777 777 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
778 778
779 779 # Copy all files from the chroot to the loop device mount point directory
780 780 rsync -a "${R}/" "$BUILDDIR/mount/"
781 781
782 782 # Unmount all temporary loop devices and mount points
783 783 cleanup
784 784
785 785 # Create block map file(s) of image(s)
786 786 if [ "$ENABLE_SPLITFS" = true ] ; then
787 787 # Create block map files for "bmaptool"
788 788 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
789 789 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
790 790
791 791 # Image was successfully created
792 792 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
793 793 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
794 794 else
795 795 # Create block map file for "bmaptool"
796 796 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
797 797
798 798 # Image was successfully created
799 799 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
800 800
801 801 # Create qemu qcow2 image
802 802 if [ "$ENABLE_QEMU" = true ] ; then
803 803 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
804 804 QEMU_SIZE=16G
805 805
806 806 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
807 807 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
808 808
809 809 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
810 810 fi
811 811 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant